Attribute VB_Name = "Souborovy_Dialog"
' By HaCeSOFT
' Pavel Prochazka
' hacesoft@mujmail.cz
' www.prochazka.zde.cz
'
'
' Tento program a knihovna AdresaPortu.dll + Knihovna.dll muzete pouzivat neomezene
'  pro NEKOMERCNI ucely!!!
'
'

Const MOVEFILE_REPLACE_EXISTING = &H1
Const FILE_ATTRIBUTE_TEMPORARY = &H100
Const FILE_BEGIN = 0
Const FILE_SHARE_READ = &H1
Const FILE_SHARE_WRITE = &H2
Const CREATE_NEW = 1
Const OPEN_EXISTING = 3
Const GENERIC_READ = &H80000000
Const GENERIC_WRITE = &H40000000
Private Const INVALID_HANDLE_VALUE = -1&

Public Declare Function SetVolumeLabel Lib "kernel32" Alias "SetVolumeLabelA" (ByVal lpRootPathName As String, ByVal lpVolumeName As String) As Long
Public Declare Function WriteFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, ByVal lpOverlapped As Any) As Long
Public Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, ByVal lpOverlapped As Any) As Long
Public Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Any, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Public Declare Function SetFilePointer Lib "kernel32" (ByVal hFile As Long, ByVal lDistanceToMove As Long, lpDistanceToMoveHigh As Long, ByVal dwMoveMethod As Long) As Long
Public Declare Function SetFileAttributes Lib "kernel32" Alias "SetFileAttributesA" (ByVal lpFileName As String, ByVal dwFileAttributes As Long) As Long
Public Declare Function GetFileSize Lib "kernel32" (ByVal hFile As Long, lpFileSizeHigh As Long) As Long
Public Declare Function GetTempFileName Lib "kernel32" Alias "GetTempFileNameA" (ByVal lpszPath As String, ByVal lpPrefixString As String, ByVal wUnique As Long, ByVal lpTempFileName As String) As Long
Public Declare Function MoveFileEx Lib "kernel32" Alias "MoveFileExA" (ByVal lpExistingFileName As String, ByVal lpNewFileName As String, ByVal dwFlags As Long) As Long
Public Declare Function DeleteFile Lib "kernel32" Alias "DeleteFileA" (ByVal lpFileName As String) As Long
Public Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Public Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long
Public Declare Function GetProcessHeap Lib "kernel32" () As Long
Public Declare Function HeapAlloc Lib "kernel32" (ByVal hHeap As Long, ByVal dwFlags As Long, ByVal dwBytes As Long) As Long
Public Declare Function HeapFree Lib "kernel32" (ByVal hHeap As Long, ByVal dwFlags As Long, lpMem As Any) As Long

Private Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    Flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

Private Type DataSearch
    Zacatek_dat As Integer
    Konec_dat As Integer
    Delka_dat As Integer
    Error As Integer
End Type

Public Function Dialog_Load()
    Dim OFName As OPENFILENAME
    Dim sMaska_1 As String
    
    Let sMaska_1 = ".txt.56"
    
    OFName.lStructSize = Len(OFName)
    OFName.hwndOwner = EEPROM.hwnd
    OFName.hInstance = App.hInstance
    OFName.lpstrFilter = "Text Files (*" + sMaska_1 + ")" + Chr$(0) + "*" + sMaska_1 + Chr$(0) + "All Files (*.*)" + Chr$(0) + "*.*" + Chr$(0)
    OFName.lpstrFile = Space$(254)
    OFName.nMaxFile = 255
    OFName.lpstrFileTitle = Space$(254)
    OFName.nMaxFileTitle = 255
    OFName.lpstrInitialDir = "D:\"
    OFName.lpstrTitle = "Open File"
    OFName.Flags = 0

    If GetOpenFileName(OFName) Then
        Dialog_Load = Trim$(OFName.lpstrFile)
    Else
       Dialog_Load = ""
    End If
End Function

Public Function Dialog_Save() As String
    Dim OFName As OPENFILENAME
    Dim Maska As Integer
    Dim sMaska_1 As String
    Dim Pripona As String
    
    Let sMaska_1 = ".txt.56"
    
    
    OFName.lStructSize = Len(OFName)
    OFName.hwndOwner = EEPROM.hwnd
    OFName.hInstance = App.hInstance
    OFName.lpstrFilter = "Text Files (*" + sMaska_1 + ")" + Chr$(0) + "*" + sMaska_1 + Chr$(0) + "All Files (*.*)" + Chr$(0) + "*.*" + Chr$(0)
    OFName.lpstrFile = Space$(254)
    OFName.nMaxFile = 255
    OFName.lpstrFileTitle = Space$(254)
    OFName.nMaxFileTitle = 255
    OFName.lpstrInitialDir = "C:\"
    OFName.lpstrTitle = "Save File"
    OFName.Flags = 0

    If GetSaveFileName(OFName) Then
        Let Maska = OFName.nFilterIndex
        If Maska = 1 Then
            Let Pripona = sMaska_1
        Else
            Let Pripona = ""
        End If
        Dialog_Save = Mid(Trim$(OFName.lpstrFile), 1, Len(Trim$(OFName.lpstrFile)) - 1) + Pripona
        
    Else
        Dialog_Save = ""
    End If
End Function

Public Function Save_File(sCesta As String, co_ulozit As String, Jaka_Pamet As Integer, Velikost_pameti As Integer) As Integer
Rem -1 == Nepodarilo se otevrit soubor
Rem -2 == Soubor nejde prepsat
Rem -3 ==
Rem -4 == Stornovano prepsani souboru

Dim hSoubor As Long
Dim rnt As Integer

Let hSoubor = CreateFile(sCesta, GENERIC_WRITE, FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0&, CREATE_NEW, 0, 0)
If hSoubor = INVALID_HANDLE_VALUE Then
    Let hSoubor = CreateFile(sCesta, GENERIC_WRITE, FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0&, OPEN_EXISTING, 0, 0)
    If hSoubor = INVALID_HANDLE_VALUE Then
        Let Save_File = -1
        Exit Function
    End If
    Let rnt = MessageBox(0, "Soubor u existuje. Chcete soubor pepsat?", App.Title, MB_YESNO Or MB_DEFBUTTON1 Or MB_ICONINFORMATION)
    
    If rnt = IDYES Then
        CloseHandle hSoubor
        DeleteFile (sCesta)
        Let hSoubor = CreateFile(sCesta, GENERIC_WRITE, FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0&, CREATE_NEW, 0, 0)
        If hSoubor = INVALID_HANDLE_VALUE Then
            Let rnt = MessageBox(0, "Soubor nejde pepsat?", App.Title, MB_OK Or MB_ICONINFORMATION)
            Let Save_File = -2
            Exit Function
        End If
        Rem zde volam ukladani do souboru (soubor uz existuje, stary smazu a vytvorim novy)
        Let rnt = Save_soubor(hSoubor, sCesta, co_ulozit, Jaka_Pamet, Velikost_pameti)

        CloseHandle hSoubor
    Else
        Let Save_File = -4
        Exit Function
    End If
Else
    Rem zde volam ukladani do souboru (novy soubor)
    Let rnt = Save_soubor(hSoubor, sCesta, co_ulozit, Jaka_Pamet, Velikost_pameti)
    
    CloseHandle hSoubor
End If
End Function

Public Function Save_soubor(hSoubor As Long, sCesta As String, co_ulozit As String, Jaka_Pamet As Integer, Velikost_pameti As Integer) As Integer
Rem -1 == soubor neni ulozen cely
Rem -2 ==

Dim rnt As Integer
Dim dwUlozeno As Long
Dim delka As Long
Dim lpBuffer() As Byte
Dim a As Integer

Let co_ulozit = "LIST: 93LC" + LTrim(str(Jaka_Pamet)) + ", " + "LENGHT: " + str(Velikost_pameti) + Chr(10) + Chr(13) + "--------------------------" + Chr(10) + Chr(13) + co_ulozit + Chr(10) + Chr(13) + "--------------------------" + Chr(10) + Chr(13) + "EEPROM Proggrammer version: " + LTrim(str(App.Major)) + "." + LTrim(str(App.Minor)) + "." + LTrim(str(App.Revision)) + "."

Let delka = Len(co_ulozit)
ReDim lpBuffer(delka) As Byte

For a = 1 To delka
    Let lpBuffer(a) = Asc(Mid(co_ulozit, a, 1))
Next a

Let rnt = WriteFile(hSoubor, lpBuffer(1), delka, dwUlozeno, ByVal 0&)
If delka <> dwUlozeno Then
    Let Save_soubor = -1
    Exit Function
    End If
End Function
Public Function Load_File(sCesta As String, Jaka_Pamet As String, Velikost_pameti As Integer) As Struc_Data
Rem -1 == Nepodarilo se otevrit soubor
Rem -2 == Chyba GetFileSize
Rem -3 == Chyba cteni souboru
Rem -4 == Chybna data, uzivatel stornoval nahravani

Dim dwVelikost As Long
Dim lpBuffer() As Byte
Dim sBuffer As String
Dim dwNacteno As Long
Dim hSoubor As Long
Dim a As Integer
Dim pozice As Long
Dim typ_pameti_je As String
Dim pokracovat As Boolean
Dim pokracovat_dal As Boolean
Dim Data_Search As DataSearch
Dim delka_stringu As String

Rem Const vbTextCompare = 1
Let hSoubor = CreateFile(sCesta, GENERIC_READ, FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0&, OPEN_EXISTING, 0, 0)
If hSoubor = INVALID_HANDLE_VALUE Then
    Let Load_File.rnt = -1
    Exit Function
End If

Let dwVelikost = GetFileSize(hSoubor, 0)
If dwVelikost = INVALID_HANDLE_VALUE Then
    CloseHandle (hSoubor)
    Let Load_File.rnt = -2
    Exit Function
End If

ReDim lpBuffer(dwVelikost) As Byte
Rem ReDim sBuffer(dwVelikost) As String

ReadFile hSoubor, lpBuffer(1), dwVelikost, dwNacteno, ByVal 0&


Rem Let lpBuffer = HeapAlloc(GetProcessHeap, 0, dwVelikost + 4)
Rem Let rnt = ReadFile(hSoubor, lpBuffer, dwVelikost, ByVal dwNacteno, ByVal 0&)
If dwNacteno <> dwVelikost Then
 Rem   rnt = HeapFree(GetProcessHeap, 0, lpBuffer)
    CloseHandle (hSoubor)
    Let Load_File.rnt = -3
    Exit Function
End If

CloseHandle (hSoubor)

For a = 1 To dwVelikost
    Let sBuffer = sBuffer + Chr(lpBuffer(a))
Next a

Let pokracovat = False
Let pokracovat_dal = False
Rem najde pro jakou EEPROMKY je vypis
Let pozice = InStr(1, sBuffer, "LIST", vbTextCompare)
If pozice <> 0 Then
    Let typ_pameti_je = Mid(sBuffer, pozice + 6, 6)
    If typ_pameti_je = Jaka_Pamet Then
        Let pokracovat = True
    Else
        Let rnt = MessageBox(0, "Nelze rozpoznat typ EEPROMky", App.Title, MB_OKCANCEL Or MB_DEFBUTTON1 Or MB_ICONINFORMATION)
        If rnt = IDOK Then
            Let pokracovat = True
        Else
            Let Load_File.rnt = -4
            Exit Function
        End If
    End If
Else
    Let rnt = MessageBox(0, "Nelze rozpoznat typ EEPROMky", App.Title, MB_OKCANCEL Or MB_DEFBUTTON1 Or MB_ICONINFORMATION)
    If rnt = IDYES Then
        Let pokracovat = True
    Else
        Let Load_File.rnt = -4
        Exit Function
    End If
End If
    
If pokracovat = True Then
    Rem najde delku vypisu
    Let pozice = InStr(1, sBuffer, "LENGHT", vbTextCompare)
    Let Velikost_pameti_je = Trim(Mid(sBuffer, pozice + 9, 4))
    If Velikost_pameti_je = Velikost_pameti Then
        Let pokracovat_dal = True
    Else
        Let rnt = MessageBox(0, "Nelze zjistit velikost EEPROMky", App.Title, MB_OKCANCEL Or MB_DEFBUTTON1 Or MB_ICONINFORMATION)
        If rnt = IDOK Then
            Let pokracovat_dal = True
        Else
            Let Load_File.rnt = -4
            Exit Function
        End If
    End If
End If
        
If pokracovat_dal = True Then
    Rem    hledani uzitecnich dat v nahranem souboru. Spravny format je cislo v hex. soustave #0 - #FF potom mezera
    Rem    ( CHAR$(32) ) a dalsi hex cislo. Cilel musi bejt tolik jak je dlouha EEPROMka, pokud ne tak se doplni
    Rem    chybejici data nulama.
    Let Data_Search = Zjisti_kde_zacinaji_data(sBuffer)
    If Data_Search.Error = -1 Then
        Let rnt = MessageBox(0, "Nelze rozpoznat obsah pameti EEPROMky", App.Title, MB_OK Or MB_ICONSTOP)
        Let Load_File.rnt = -5
        Exit Function
    Else
        Rem nacitani dat a ukladani do vypis.text
        Let delka_stringu = Data_Search.Konec_dat - Data_Search.Zacatek_dat
        If Data_Search.Delka_dat > Velikost_pameti Then
            Let rnt = MessageBox(0, "Pebyten data budou zahozena!", App.Title, MB_OK Or MB_ICONINFORMATION)
            Let delka_stringu = (Velikost_pameti * 3) - 1
        End If
        Let Load_File.sBuffer = Mid(sBuffer, Data_Search.Zacatek_dat, delka_stringu)
    End If
End If
End Function

Private Function Zjisti_kde_zacinaji_data(sBuffer As String) As DataSearch
Rem zjistim kde zacinaji data a provedu validaci dat.
Rem pokud data nebudou ok tak vratim -1.
Dim a As Integer
Dim sdelka As Integer
Dim jeden_znak As String
Dim platny_znak As Boolean
Dim ulozit_jednou As Boolean
Rem Dim Zacatek_dat As Integer
Dim pocitadlo_znaku As Integer
Dim pocitadlo_mezer As Integer
Rem Dim hledej_dalsi_znak As Boolean

Let pocitadlo_znaku = 0
Let pocitadlo_mezer = 0
Let ulozit_jednou = True
Let platny_znak = True
Let sdelka = Len(sBuffer)
For a = 1 To sdelka
    Let jeden_znak = Asc(Mid(sBuffer, a, 1))
    Rem Debug.Print Chr(jeden_znak)
    Select Case jeden_znak   ' Vyhodnocen promnn jeden_znak.
        Case 48 To 57        ' znaku 0 az 9
            Let platny_znak = True
            If pocitadlo_mezer > 0 Then
                Let ulozit_jednou = False
            End If
        Case 32              'mezera
            Let platny_znak = False
            If pocitadlo_znaku = 2 Then
                Let pocitadlo_mezer = pocitadlo_mezer + 1
                Let pocitadlo_znaku = 0
            Else
                Let pocitadlo_znaku = 0
                Let pocitadlo_mezer = 0
            End If
        Case 97 To 102      ' znaky A az F
            Let platny_znak = True
            If pocitadlo_mezer > 0 Then
                Let ulozit_jednou = False
            End If
        Case 65 To 70       ' znaky a az f
            Let platny_znak = True
            If pocitadlo_mezer > 0 Then
                Let ulozit_jednou = False
            End If
        Case Else
            Let platny_znak = False
            Let pocitadlo_znaku = 0
            If pocitadlo_mezer > 4 Then
                Let Zjisti_kde_zacinaji_data.Konec_dat = a
                Let Zjisti_kde_zacinaji_data.Error = 0
                Exit For
            Else
                Let ulozit_jednou = True
                Let Zjisti_kde_zacinaji_data.Delka_dat = 0
                Let Zjisti_kde_zacinaji_data.Error = -1
                Let Zjisti_kde_zacinaji_data.Konec_dat = 0
                Let Zjisti_kde_zacinaji_data.Zacatek_dat = -1
            End If
            Let pocitadlo_mezer = 0
            Rem Let hledej_dalsi_znak = False
    End Select
If platny_znak = True Then
    If ulozit_jednou = True Then
        Let Zjisti_kde_zacinaji_data.Zacatek_dat = a - 1
    End If
    Let pocitadlo_znaku = pocitadlo_znaku + 1
    Let Zjisti_kde_zacinaji_data.Delka_dat = Zjisti_kde_zacinaji_data.Delka_dat + 1
 Rem   If pocitadlo_znaku = 2 Then
        Rem asi jsem nasel hexa cislo. tak ho prevedu na dekadicke pro jistotu :-)
 Rem   End If
End If
Next a
Let Zjisti_kde_zacinaji_data.Delka_dat = Zjisti_kde_zacinaji_data.Delka_dat / 2
End Function

Public Function End_File()
Rem Let rnt = HeapFree(GetProcessHeap, 0, lpBuffer)
'CloseHandle (hSoubor)
End Function

 
